# Docker下通过Dockerfile部署Jar包

- **拷贝程序文件到服务器**

  ```shell
  mkdir /home/tmp
  cd /home/tmp
  
  ```

  

- **在该目录创建Dockerfile文件**

  ```shell
  vim Dockerfile 
  ```

  

- **修改 Dockerfile 文件并保存**

  ```tex
  # 拉取一个jdk为1.8的docker镜像作为基础镜像
  FROM java:8
  # 申明作者
  MAINTAINER mengyxu
  #拷贝程序文件
  COPY . /
  #暴露端口
  EXPOSE 8080
  # 容器启动之后执行的命令， java -jar /picture.jar
  ENTRYPOINT ["java","-jar","/picture.jar"]
  ```

- **执行命令，构建镜像**

  ```shel
  docker build -t mengyxu/picture .
  ```

  **注意：最后的点号，表示在Dockerfile文件在当前目录下，`mengyxu/picture`表示构建后的镜像名称。**

- 创建并运行容器

  ```shell
  docker run -d --restart=always --privileged -p 8080:8080 \
  -v /home/nginx/data/image/:/image/ \
  -v /home/picture-docker/application.properties:/application.properties \
  -v /home/picture-docker/log4j2.xml:/log4j2.xml mengyxu/picture
  ```
  
  