# 服务端

## 使用docker安装

- 查找下载镜像

  ```shell
  #查询mongo镜像
  docker search mongo
  #下载最新版本镜像
  docker pull mongo:latest
  ```

- 运行容器

  ```shell
  docker run -itd --name mongo -p 27017:27017 mongo --auth
  ```

  - **-p 27017:27017** ：映射容器服务的 27017 端口到宿主机的 27017 端口。外部可以直接通过 宿主机 ip:27017 访问到 mongo 的服务。
  - **--auth**：需要密码才能访问容器服务。

- 添加用户和设置密码

  ```shell
  docker exec -it mongo mongo admin
  #创建一个名为 admin，密码为 123456 的用户。
  >  db.createUser({ user:'admin',pwd:'123456',roles:[ { role:'userAdminAnyDatabase', db: 'admin'},"readWriteAnyDatabase"]});
  # 尝试使用上面创建的用户信息进行连接。
  > db.auth('admin', '123456')
  ```

  

## 官网下载文件方式

- [官方下载地址](https://www.mongodb.com/download-center#community)

  选择**On-premises MongoDB locally  -> MongoDB Community Server **

  右边窗口选择版本与系统，类型为tgz，点击 **Copy Link**

- 下载安装包

  ```shell
  wget https://fastdl.mongodb.org/linux/mongodb-linux-x86_64-rhel70-5.0.7.tgz
  ```

- 安装与配置

  ```shell
  tar -zxvf mongodb-linux-x86_64-rhel70-5.0.7.tgz 
  mv mongodb-linux-x86_64-rhel70-5.0.7 mongo5.0.7
  ```

- 配置

  配置环境变量

  ```tex
  export MONGO_HOME=/home/work/mengyxu/mongo5.0.7
  export PATH=$MONGO_HOME/bin:$PATH
  ```

  创建数据和日志目录，默认情况下

  - 数据存储目录：/var/lib/mongodb
  - 日志文件目录：/var/log/mongodb

  ```shell
  mkdir /home/work/mengyxu/mongo5.0.7/data
  mkdir /home/work/mengyxu/mongo5.0.7/log
  ```

- 启动

  ```shell
  mongod --dbpath /home/work/mengyxu/mongo5.0.7/data --logpath /home/work/mengyxu/mongo5.0.7/log/mongod.log --fork
  ```

  
