# 服务端

## 使用docker安装

- 下载镜像

```shell
docker pull teddysun/trojan-go

sudo docker run --name hbbs -p 21114:21114 -p 21115:21115 -p 21116:21116 -p 21116:21116/udp -p 21118:21118 -v /home/rustDesk:/root -itd --rm rustdesk/rustdesk-server hbbs -r hbbr.xumy.vip -m demo
		
docker run --name hbbr -p 21117:21117 -p 21119:21119 -v /home/rustDesk:/root -itd --rm rustdesk/rustdesk-server hbbr -m demo

```

- 添加配置

  ```shell
  mkdir /home/trojan-go
  vim /home/trojan-go/config.json
  ```

  ```tex
  {
      "run_type": "server",
      "local_addr": "172.17.0.1",
      "local_port": 443,
      "remote_addr": "172.17.0.1",
      "remote_port": 80,
      "password": [
          "iaminlove.20."
      ],
      "ssl": {
          "cert": "/etc/trojan-go/go.xumy.vip_bundle.crt",
          "key": "/etc/trojan-go/go.xumy.vip.key",
          "sni": "go.xumy.vip"
      }
  }
  ```

  

- 创建并运行容器

```tex
docker run -itd --name trojan-go --restart=always --net host -v /home/trojan-go:/etc/trojan-go teddysun/trojan-go
```

