# 安装卸载

## 使用安装包

- 下载

  [官方下载地址](https://dev.mysql.com/downloads/repo/yum/)

  ```
  wget http://repo.mysql.com/mysql-community-release-el7-5.noarch.rpm
  ```

- 安装

  ```shell
  rpm -ivh mysql-community-release-el7-5.noarch.rpm
  yum update
  yum install mysql-server
  ```

- 设置数据目录权限

  ```shell
  chown -R mysql:mysql /var/lib/mysql
  ```

- 初始化

  ```shell
  mysqld --initialize
  ```

- 启动与停止

  ```
  systemctl start mysqld		//启动
  systemctl status mysqld		//查看运行状态
  systemctl stop mysqld		//停止
  systemctl restart mysqld	//重启
  ```

- 查看版本

  ```shell
  mysqladmin --version
  ```

- 卸载

  ```shell
  rpm -e mysql　　// 普通删除模式
  rpm -e --nodeps mysql　　// 强力删除模式，如果使用上面命令删除时，提示有依赖的其它文件，则用该命令可以对其进行强力删除
  ```

  

## 使用docker

- 安装**docker**

- 下载镜像

  ```shell
  docker pull mysql:5.7.27
  ```

- 创建数据存储目录

  ```shell
  mkdir /home/mysql
  mkdir /home/mysql/data /home/mysql/conf /home/mysql/log
  ```

  

- 创建并运行容器

  ```shell
  docker run -itd --name mysql-server --net host -v /home/mysql/data:/var/lib/mysql -v /home/mysql/conf:/etc/mysql -v /home/mysql/log:/var/log/mysql -e MYSQL_ROOT_PASSWORD=123456 mysql:5.7.27
  ```

- 启动与停止容器

- 卸载

  删除容器和镜像

  ```shell
  docker rm -f mysql-server
  docker rm mysql:5.7.27
  ```

  删除数据

  ```shell
  rm -rf /home/mysql
  ```

  

# 配置

## 配置文件

- 位置

  目录为`/etc/mysql`,默认使用`my.cnf`文件配置，`conf.d`目录下所有`.cnf`文件中配置项可覆盖默认配置

  
