# 安装卸载

## 使用docker

- 安装**docker**

- 安装并启动**mysql**

- 安装并启动**redis**

- 安装 **masterlab**

  - 下载`masterlab-docker`与`masterlab`最新代码

    ```shell
    cd /home
    git clone https://gitee.com/firego/masterlab-docker.git
    cd ./masterlab-docker/www
    git clone https://gitee.com/firego/masterlab.git
    cd ./masterlab
    unzip ./vendor.zip
    ```

  - 下载镜像

    ```shell
    docker pull gopeak/masterlab:php-fpm-74
    docker pull nginx:alpine
    docker pull gopeak/masterlab:php-cli-74
    ```

  - 创建容器

    需按顺序创建

    ```shell
    docker run -d --name php74 --expose=9000 -p 9000:9000 --link mysql-server:mysql --link redis:redis  \
     -v /home/masterlab-docker/www/:/var/www/html/ \
     -v /home/masterlab-docker/conf/php/php74.ini:/usr/local/etc/php/php.ini \
     -v /home/masterlab-docker/conf/php/php-fpm.d/www74.conf:/usr/local/etc/php-fpm.d/www.conf \
     -v /home/masterlab-docker/log/php-fpm/:/var/log/php-fpm/ \
      gopeak/masterlab:php-fpm-74
      
      docker run -d --name nginx-alpine -p 80:80 -p 443:443 --link php74:fpm74 \
     -v /home/masterlab-docker/www/:/var/www/html/ \
     -v /home/masterlab-docker/conf/nginx/conf.d:/etc/nginx/conf.d/ \
     -v /home/masterlab-docker/conf/nginx/nginx.conf:/etc/nginx/nginx.conf \
     -v /home/masterlab-docker/log/nginx/:/var/log/nginx/ \
     -e "TZ=Asia/Shanghai" \
     nginx:alpine
    ```

    `gopeak/masterlab:php-cli-74`为异步邮件发送服务，如不启用异步邮件发送，可以不创建

    ```shell
    docker run -d -it --rm --name php74-cli \
        -p 9002:9002 \
        -v /home/masterlab-docker/www/masterlab:/usr/workspaces/project \
        -w /usr/workspaces/project \
        gopeak/masterlab:php-cli-74 \
        php  ./bin/swoole_server.php
    ```

  - 启动与停止

    启动顺序与创建顺序一致

  - 卸载

    删除相关容器、镜像与数据

