

# 基础语法

## 标题

Markdown支持6种级别的标题，对应html标签 **h1 ~ h6**

```markdown
# h1
## h2
### h3
#### h4
##### h5
###### h6
```

# h1
## h2
### h3
#### h4
##### h5
###### h6

Markdown还支持另外一种形式的标题展示形式，使用下划线进行文本大小的控制

```markdown
这是一级标题
===
这是二级标题
---
```

这是一级标题
===
这是二级标题
---

缺点是文字大小控制级别有限



## 段落及区块引用

```markdown
> 这段文字将被会有区块标记...
```

> 这段文字将被会有区块标记...

## 插入链接或图片

```markdown
[点击跳转至百度](http://www.baidu.com)
![图片](https://upload-images.jianshu.io/upload_images/703764-605e3cc2ecb664f6.jpg?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)
```

注： 引用图片和链接的唯一区别就是在最前方添加一个感叹号。

[点击跳转至百度](http://www.baidu.com)
![图片](https://upload-images.jianshu.io/upload_images/703764-605e3cc2ecb664f6.jpg?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

## 列表

```markdown
* 黄瓜
* 玉米
* 茄子

+ 黄瓜
+ 玉米
+ 茄子

- 黄瓜
- 玉米
- 茄子

2. 黄瓜	//编号列表中，Markdown将只关注你的第一项的数字编号
1. 玉米	//第一项编号是2，以此类推，第二项应该是3
2. 茄子	//第三项应该是4
```

* 黄瓜
* 玉米
* 茄子

+ 黄瓜
+ 玉米
+ 茄子

- 黄瓜
- 玉米
- 茄子

2. 黄瓜
3. 玉米
4. 茄子

### 使用列表的一些注意事项

如果在单一列表项中包含了多个段落，为了保证渲染正常，*与段落首字母之间必须保留四个空格

```markdown
*    段落一

     小段一
*    段落二

     小段二
```

*    段落一

     小段一
*    段落二

     小段二

如果在列表中加入了区块引用，区域引用标记符也需要缩进4个空格

```markdown
* 段落一
    > 区块标记一
* 段落二
    > 区块标记二
```

* 段落一
  
    > 区块标记一
* 段落二
  
    > 区块标记二

## 分隔线

```markdown
***
---
```

***
---

符号之间添加空格也可以

## 强调

```markdown
*这里是斜体*
_这里是斜体_

**这里是加粗**
__这里是加粗__
```

*这里是斜体*
_这里是斜体_

**这里是加粗**
__这里是加粗__

# 高级用法

## 代码块

如果是行内代码引用，使用单个反引号进行包裹

```
这是一段`var x = 3`行内代码
```

这是一段`var x = 3`行内代码

如果插入一整段代码，使用三个以上反引号进行包裹

````markdown
```javascript
fun (x: Int, y: Int): Int {
  return x + y
}
```
````

```javascript
fun (x: Int, y: Int): Int {
  return x + y
}
```

## 表格

```markdown
表头|条目一|条目二
:---:|:---:|:---:
项目|项目一|项目二
```

| 表头 | 条目一 | 条目二 |
| :--: | :----: | :----: |
| 项目 | 项目一 | 项目二 |

三个短斜杠左右的冒号用于控制对齐方式，只放置左边冒号表示文字居左，只放置右边冒号表示文字居右，如果两边都放置冒号表示文字居中

# 其他

## 特殊符号处理

使用反斜杠\插入语法中用到的特殊符号

```markdown
\\   反斜线
\`   反引号
\*   星号
\_   底线
\{}  花括号
\[]  方括号
\()  括弧
\#   井字号
\+   加号
\-   减号
\.   英文句点
\!   惊叹号
```

\\   反斜线
\`   反引号
\*   星号
\_   底线
\{}  花括号
\[]  方括号
\()  括弧
\#   井字号
\+   加号
\-   减号
\.   英文句点
\!   惊叹号

# Markdown编辑器

推荐使用**Typora**

